package com.steerinfo.dil.controller;

import com.steerinfo.dil.service.impl.TmstruckSelfMachineService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.xml.crypto.Data;
import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author luobang
 * @create 2021-11-17 20:32
 */
@RestController
@RequestMapping("/${api.version}/selfMachine")
public class TmstruckSelfMachineController extends BaseRESTfulController {

    @Autowired
    TmstruckSelfMachineService tmstruckSelfMachineService;

    /**
     * 提货单
     * @param orderNumber
     * @return
     */
    @PostMapping("/getBillOrder")
    public Map<String, Object> getBILLOrder(@RequestParam String orderNumber){
       Map<String,Object>map= tmstruckSelfMachineService.getBillOrder(orderNumber);
       return map;
    }

    /**
     * 打印提货单
     * @param orderNumber
     * @return
     */
    @PostMapping("/getBillOrderForPrinter")
    public List<Map<String, Object>> getBillOrderForPrinter(@RequestParam String orderNumber){
        return tmstruckSelfMachineService.getBillOrderForPrinter(orderNumber);
    }

    /**
     * 送货单
     * @param orderNumber
     * @return
     */
    @PostMapping("/getDeliveryOrder")
    public Map<String,Object>getDeliveryOrder(@RequestParam String orderNumber){
        Map<String,Object>map=tmstruckSelfMachineService.getDeliveryOrder(orderNumber);
        return map;
    }

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-04
     * @Description:
    */
    @PostMapping("/queryNumber")
    public Map<String,Object> queryNumber(@RequestParam String orderNumber){
        Map<String,Object> bigDecimal=new HashMap<>();
        bigDecimal.put("printnumber",0);
        Map<String,Object> bigDecimal1 = tmstruckSelfMachineService.queryNumber(orderNumber);
        if(bigDecimal1 == null
        || (DataChange.dataToBigDecimal(bigDecimal1.get("printnumber")).intValue() > 5)
        || (bigDecimal1.get("printDate")!=null && new Date().getTime() - ((Date)bigDecimal1.get("printDate")).getTime() < 1000*60*3)) {
            bigDecimal.put("printnumber",1);
        }
        return bigDecimal;
    }

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-04
     * @Description:
     */
    @PostMapping("/changeNumber")
    public void changeNumber(@RequestParam String orderNumber){

        tmstruckSelfMachineService.changeNumber(orderNumber);

    }
}
