package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckLeaveFactoryResult;
import com.steerinfo.dil.model.TmstruckReturnResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckReturnResultMapper extends IBaseMapper<TmstruckReturnResult, BigDecimal> {

    //查询最大ID值
    @Select("select seq_tmstruck_return.nextval from dual")
    BigDecimal selectMaxId();

    //通过运输订单号查询总实绩Id
    Map<String, Object> getResultTotalIdByOrderNumber(String orderNumber);

    //通过运输订单ID查询上一个订单的信息
    Map<String, Object> getOldOrderMesById(BigDecimal orderId);

    //通过运输订单Id查询查询上一个订单子表的信息
    List<Map<String, Object>> getOldOrderMaterialMesByOrderId(BigDecimal orderId);

    //通过运输订单号查询预设路径的作业点ID  及 总实绩ID
    Map<String, Object> getPointIdByOrderNum(Map<String, Object> map);

    //查询辅料退货实绩
    List<Map<String, Object>> getFLReturnResult(Map<String, Object> map);

    //清除重复实绩
    int clearRepeat(TmstruckReturnResult tmstruckReturnResult);
}