package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckSmsRusult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckSmsRusultMapper extends IBaseMapper<TmstruckSmsRusult, BigDecimal> {


    String getDriverTel(BigDecimal orderId);

    //查询最大ID
    @Select("select seq_tmstruck_sms.nextval from dual")
    BigDecimal selectMaxId();
    //根据运输订单号查找托运方
    Integer selectShipperIdByOrderNumber(String orderNumber);
    //根据运输订单号查找司机姓名
    String selectCarDriverByOrderNumber(String orderNumber);
    //查询短信实绩
    List<Map<String,Object>> selectSmsResult(Map<String,Object> map);

    Map<String,Object> selectIdApp(BigDecimal bigDecimal);

    int updateTotalResultSmsStatus(BigDecimal resultTotalId);

}