package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.TmstruckTimeTaskResult;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckTimeTaskResultMapper extends IBaseMapper<TmstruckTimeTaskResult, BigDecimal> {

    //查询最大ID
    @Select("select seq_time_task.nextval from dual")
    BigDecimal selectMaxId();

    //通过运输订单号 查询总实绩ID
    Map<String, Object> getResultTotalIdByOrderNum(String orderNumber);

    //查询上一次用车单位确认暂停结束时间
    Map<String, Object> getLastTimeout(BigDecimal resultTotalId);

    //查询上一次用车单位确认暂停 确认结束时间
    Map<String, Object> getLastTimeEnd(BigDecimal resultTotalId);

    //查询用车单位确认开始时间
    Map<String, Object> getStartTime(BigDecimal resultTotalId);

    //查询所有确认暂停结束时间
    List<Map<String, Object>> getAllTimeout(BigDecimal resultTotalId);

    //查询计时(计次)作业
    List<Map<String, Object>> getAllTimeTaskResult(Map<String, Object> map);

    //删除错误计时实绩
    int deleteErrorTimeTaskResult();

    //根据运输订单号查找需要用车时长
    Map<String,Object>  selectInwardDueTimeByOrderId(BigDecimal orderId);

    //根据运输订单id查找实绩中是否含有已经计时开始的实绩
    int CountStartTaskByOrderId(BigDecimal orderId);

    //根据运输订单id查找实绩中是否含有已经计时结束的实绩
    int CountTimeTaskByOrderId(BigDecimal orderId);

    Map<String,Object> getRequirementInfo(BigDecimal orderId1);

    //查询最新步骤
    Integer getLastStep(BigDecimal orderId);

    //查找计时开始时间
    List<Map<String,Object>> getStartTimeTask(Map<String,Object> map);

    //查找总时长
    Map<String,Object> getResultValue(String orderNumber);

    //根据运输订单号查询用车单位
    String getShipperName(Map<String,Object> map);


    //校验订单类型是否符合计时要求
    int checkOrderType(BigDecimal orderId);
}