package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="车辆时间线")
public class DilCapacityTimes implements IBasePO<BigDecimal> {
    /**
     * 主键ID(TIMES_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal timesId;

    /**
     * 时间(TIMES_VALUE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="时间",required=false)
    private Date timesValue;

    /**
     * 类型(1:进厂；2:出厂)(TIMES_TYPE,DECIMAL,38)
     */
    @ApiModelProperty(value="类型(1:进厂；2:出厂)",required=false)
    private BigDecimal timesType;

    /**
     * 备注(TIMES_REMARK,VARCHAR,200)
     */
    @ApiModelProperty(value="备注",required=false)
    private String timesRemark;

    /**
     * 车牌号(TIMES_CAPACITY_NUMBER,VARCHAR,255)
     */
    @ApiModelProperty(value="车牌号",required=false)
    private String timesCapacityNumber;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.timesId;
    }

    @Override
    public void setId(BigDecimal timesId) {
        this.timesId = timesId;
    }

    public BigDecimal getTimesId() {
        return timesId;
    }

    public void setTimesId(BigDecimal timesId) {
        this.timesId = timesId;
    }

    public Date getTimesValue() {
        return timesValue;
    }

    public void setTimesValue(Date timesValue) {
        this.timesValue = timesValue;
    }

    public BigDecimal getTimesType() {
        return timesType;
    }

    public void setTimesType(BigDecimal timesType) {
        this.timesType = timesType;
    }

    public String getTimesRemark() {
        return timesRemark;
    }

    public void setTimesRemark(String timesRemark) {
        this.timesRemark = timesRemark == null ? null : timesRemark.trim();
    }

    public String getTimesCapacityNumber() {
        return timesCapacityNumber;
    }

    public void setTimesCapacityNumber(String timesCapacityNumber) {
        this.timesCapacityNumber = timesCapacityNumber == null ? null : timesCapacityNumber.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", timesId=").append(timesId);
        sb.append(", timesValue=").append(timesValue);
        sb.append(", timesType=").append(timesType);
        sb.append(", timesRemark=").append(timesRemark);
        sb.append(", timesCapacityNumber=").append(timesCapacityNumber);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}