package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="仓库")
public class RmsWarehouse implements IBasePO<BigDecimal> {
    /**
     * 主键ID(WAREHOUSE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal warehouseId;

    /**
     * 仓库类型ID(WAREHOUSE_TYPE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="仓库类型ID",required=false)
    private BigDecimal warehouseTypeId;

    /**
     * 港存库所属港口ID(PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="港存库所属港口ID",required=false)
    private BigDecimal portId;

    /**
     * 仓库名称(一棒库，二棒库，高线库，配送库,某某港的港存库)(WAREHOUSE_NAME,VARCHAR,50)
     */
    @ApiModelProperty(value="仓库名称(一棒库，二棒库，高线库，配送库,某某港的港存库)",required=false)
    private String warehouseName;

    /**
     * 仓库容量(WAREHOUSE_CAPACITY,DECIMAL,0)
     */
    @ApiModelProperty(value="仓库容量",required=false)
    private BigDecimal warehouseCapacity;

    /**
     * 仓库经度(WAREHOUSE_LONGITUDE,VARCHAR,20)
     */
    @ApiModelProperty(value="仓库经度",required=false)
    private String warehouseLongitude;

    /**
     * 仓库纬度(WAREHOUSE_LATITUDE,VARCHAR,20)
     */
    @ApiModelProperty(value="仓库纬度",required=false)
    private String warehouseLatitude;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除",required=false)
    private BigDecimal deleted;

    /*
     * 托运人Id
     * */
    @ApiModelProperty(value = "托运人",required = false)
    private BigDecimal shipperId;

    public BigDecimal getShipperId() {
        return shipperId;
    }

    public void setShipperId(BigDecimal shipperId) {
        this.shipperId = shipperId;
    }

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.warehouseId;
    }

    @Override
    public void setId(BigDecimal warehouseId) {
        this.warehouseId = warehouseId;
    }

    public BigDecimal getWarehouseId() {
        return warehouseId;
    }

    public void setWarehouseId(BigDecimal warehouseId) {
        this.warehouseId = warehouseId;
    }

    public BigDecimal getWarehouseTypeId() {
        return warehouseTypeId;
    }

    public void setWarehouseTypeId(BigDecimal warehouseTypeId) {
        this.warehouseTypeId = warehouseTypeId;
    }

    public BigDecimal getPortId() {
        return portId;
    }

    public void setPortId(BigDecimal portId) {
        this.portId = portId;
    }

    public String getWarehouseName() {
        return warehouseName;
    }

    public void setWarehouseName(String warehouseName) {
        this.warehouseName = warehouseName == null ? null : warehouseName.trim();
    }

    public BigDecimal getWarehouseCapacity() {
        return warehouseCapacity;
    }

    public void setWarehouseCapacity(BigDecimal warehouseCapacity) {
        this.warehouseCapacity = warehouseCapacity;
    }

    public String getWarehouseLongitude() {
        return warehouseLongitude;
    }

    public void setWarehouseLongitude(String warehouseLongitude) {
        this.warehouseLongitude = warehouseLongitude == null ? null : warehouseLongitude.trim();
    }

    public String getWarehouseLatitude() {
        return warehouseLatitude;
    }

    public void setWarehouseLatitude(String warehouseLatitude) {
        this.warehouseLatitude = warehouseLatitude == null ? null : warehouseLatitude.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", warehouseId=").append(warehouseId);
        sb.append(", warehouseTypeId=").append(warehouseTypeId);
        sb.append(", portId=").append(portId);
        sb.append(", warehouseName=").append(warehouseName);
        sb.append(", warehouseCapacity=").append(warehouseCapacity);
        sb.append(", warehouseLongitude=").append(warehouseLongitude);
        sb.append(", warehouseLatitude=").append(warehouseLatitude);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}